----------------------------------------------------------------------
-- file:   application_message.sql
-- action: alter/create database package for WS CWS
-- usage:  connect as SYSTEM
--         run this script
--


set echo on

spool application_message.log

alter session set CURRENT_SCHEMA = CWS_DATA;

create or replace
package APPLICATION_MESSAGE
is
  procedure ADD_MESSAGE
  ( MESSAGE_TO      in  varchar2
  , MESSAGE_SUBJECT in  varchar2
  , MESSAGE_CONTENT in  varchar2
  , ERROR_TEXT      out varchar2
  );

  procedure GET_MESSAGE
  ( MESSAGE_FROM    out varchar2
  , MESSAGE_SUBJECT out varchar2
  , MESSAGE_CONTENT out varchar2
  , MESSAGE_NUMBER  out number
  , ENQUEUE_TIME    out date
  , ERROR_TEXT      out varchar2
  );
end APPLICATION_MESSAGE;
/

show errors

create or replace
package BODY APPLICATION_MESSAGE
is
  procedure ADD_MESSAGE
  ( MESSAGE_TO      in  varchar2
  , MESSAGE_SUBJECT in  varchar2
  , MESSAGE_CONTENT in  varchar2
  , ERROR_TEXT      out varchar2
  )
  is
  begin
    MESSAGE.ADD_MESSAGE
     ( MESSAGE_TO
     , user
     , MESSAGE_SUBJECT
     , MESSAGE_CONTENT
     , ERROR_TEXT
     );
  end ADD_MESSAGE;

  procedure GET_MESSAGE
  ( MESSAGE_FROM    out varchar2
  , MESSAGE_SUBJECT out varchar2
  , MESSAGE_CONTENT out varchar2
  , MESSAGE_NUMBER  out number
  , ENQUEUE_TIME    out date
  , ERROR_TEXT      out varchar2
  )
  is
  begin
    MESSAGE.GET_MESSAGE
     ( user
     , MESSAGE_FROM
     , MESSAGE_SUBJECT
     , MESSAGE_CONTENT
     , MESSAGE_NUMBER
     , ENQUEUE_TIME
     , ERROR_TEXT
     );
  end GET_MESSAGE;
end APPLICATION_MESSAGE;
/

show errors

spool off
