----------------------------------------------------------------------
-- file:   cws_access.sql
-- action: create CWS accounts and roles
-- usage:  connect as SYSTEM
--         run this script
--
----------------------------------------------------------------------

set echo off
set define on
set verify off

accept DAT_PASSWORD char prompt 'Password for CWS_DATA   => '
prompt
accept EDD_PASSWORD char prompt 'Password for EDDIES      => '


set echo on

spool cws_access.log

create user CWS_DATA
 identified by &&DAT_PASSWORD
 default tablespace USERS
 quota unlimited on USERS
 profile DEFAULT
;

create user EDDIES
 identified by &&EDD_PASSWORD
 default tablespace USERS
 profile DEFAULT
;

create role CWS_CONNECTOR;
create role EDS_CONNECTOR;

grant CREATE SESSION to CWS_CONNECTOR;
grant CREATE SESSION to EDS_CONNECTOR;

grant CWS_CONNECTOR to EDDIES;

alter user EDDIES      default role all;

spool off
