----------------------------------------------------------------------
-- file:   cws_message.sql
-- action: create CWS message objects
-- usage:  connect as SYSTEM
--         run this script
--
----------------------------------------------------------------------

spool cws_message.log

set echo on

grant execute on DBMS_AQ    to CWS_DATA;
grant execute on DBMS_AQADM to CWS_DATA;

alter session set CURRENT_SCHEMA = CWS_DATA;

create sequence SEQ_MESSAGE_NUMBERS maxvalue 999999999;

create type MESSAGE_TYPE as object
 ( MESSAGE_NUMBER   number(9)
 , MESSAGE_TO       varchar2(100)
 , MESSAGE_FROM     varchar2(100)
 , MESSAGE_SUBJECT  varchar2(100)
 , MESSAGE_CONTENT  varchar2(1000)
 );
/

begin
  DBMS_AQADM.create_queue_table
  ( queue_table        => 'CWS_DATA.MESSAGE_QUEUE_TABLE'
  , queue_payload_type => 'CWS_DATA.MESSAGE_TYPE'
  );
  DBMS_AQADM.create_queue
  ( queue_name     => 'CWS_DATA.MESSAGE_QUEUE'
  , queue_table    => 'CWS_DATA.MESSAGE_QUEUE_TABLE'
  , retention_time => DBMS_AQADM.INFINITE
  );
  DBMS_AQADM.start_queue
  ( queue_name => 'CWS_DATA.MESSAGE_QUEUE'
  );
end;
/

create or replace
view MESSAGES
 ( MESSAGE_NUMBER
 , MESSAGE_TO
 , MESSAGE_FROM
 , MESSAGE_SUBJECT
 , MESSAGE_CONTENT
 , ENQUEUE_TIME
 , DEQUEUE_TIME
 ) as
 select
   (user_data).MESSAGE_NUMBER
 , (user_data).MESSAGE_TO
 , (user_data).MESSAGE_FROM
 , (user_data).MESSAGE_SUBJECT
 , (user_data).MESSAGE_CONTENT
 , ENQ_TIME
 , DEQ_TIME
 from MESSAGE_QUEUE_TABLE;

@message.sql

@application_message.sql

spool off
